;--------------------------------------------------------------------------
;PicBoard2 Demo v1.0
;Copyright by Adam Jurkiewicz, 08.02.2004
;Source: http://ajpic.zonk.pl/
;E-mail: sword@ajpic.zonk.pl
;--------------------------------------------------------------------------

                Processor       16F877
                Radix           dec
                errorlevel      -302

                include         <p16f877.inc>
                include         <makra.asm>

                __config _BODEN_ON & _CP_OFF & _PWRTE_ON & _WDT_OFF & _LVP_OFF & _HS_OSC

;--------------------------------------------------------------------------
;definicja stalych
;--------------------------------------------------------------------------

#define XTAL            11059200         ;wartosc przylaczonego kwarcu [Hz]

#define DEL             200              ;opoznienie

;--------------------------------------------------------------------------

#define OUTLED1         PORTA
#define OUTLED2         PORTD
#define KEYIN           PORTB

#define P3              KEYIN, 7
#define P2              KEYIN, 6
#define P1              KEYIN, 5
#define P0              KEYIN, 4

;--------------------------------------------------------------------------
;deklaracja zmiennych
;--------------------------------------------------------------------------

RAM0            equ     0x20             ;poczatek pamieci RAM w banku 0
RAM1            equ     0xA0             ;poczatek pamieci RAM w banku 1
RAMCOM          equ     0x70             ;poczatek wspolnej pamieci RAM

              cblock  RAM0               ;blok zmiennych
                DELAY_L
                DELAY_H
                OUT
                OUT1
                OUT2
                COUNT
                DELAYN
                CURRRENT_LINE
              endc

;--------------------------------------------------------------------------

                org     0x0000           ;wektor resetu
                goto    start

;--------------------------------------------------------------------------

                org     0x0004           ;wektor przerwania
                retfie

;--------------------------------------------------------------------------
line0:                                   ;tablica 0 z danymi
                andlw   0x0f
                addwf   PCL, F
                retlw   00000001b
                retlw   00000010b
                retlw   00000100b
                retlw   00001000b
                retlw   00001000b
                retlw   00000100b
                retlw   00000010b
                retlw   00000001b

;--------------------------------------------------------------------------
line1:                                   ;tablica 1 z danymi
                andlw   0x0f
                addwf   PCL, F
                retlw   00000110b
                retlw   00001001b
                retlw   00000110b
                retlw   00001001b
                retlw   00000110b
                retlw   00001001b
                retlw   00000110b
                retlw   00001001b

;--------------------------------------------------------------------------
line2:                                   ;tablica 2 z danymi
                andlw   0x0f
                addwf   PCL, F
                retlw   00001010b
                retlw   00000101b
                retlw   00001010b
                retlw   00000101b
                retlw   00001010b
                retlw   00000101b
                retlw   00001010b
                retlw   00000101b

;--------------------------------------------------------------------------
line3:                                   ;tablica 3 z danymi
                andlw   0x0f
                addwf   PCL, F
                retlw   00000001b
                retlw   00000011b
                retlw   00000111b
                retlw   00001111b
                retlw   00001111b
                retlw   00000111b
                retlw   00000011b
                retlw   00000001b

;--------------------------------------------------------------------------
delay1:
                movl    DELAY_H, high (XTAL / DEL)
                movl    DELAY_L, low  (XTAL / DEL)
                djnz    DELAY_L, $ - 1
                djnz    DELAY_H, $ - 5

                return

;--------------------------------------------------------------------------
;--------------------------------------------------------------------------
;--------------------------------------------------------------------------

start:
                bank_1
                movl    OUTLED1, 0xf3
                movl    KEYIN, 0xf0
                movl    OUTLED2, 0xfc
                movl    ADCON1, 0x06
                bsf     P3
                bcf     _RBPU            ;zalacz pullup'y na RB
                bank0

                movl    CURRRENT_LINE, 0x01      ;ustaw domyslna tablice
                clrf    COUNT            ;ustaw licznik pozycji
main_1:
                movf    COUNT, W         ;ustaw wskaznik
                callb   CURRRENT_LINE, 0, line0  ;pobierz dana z tablicy
                callb   CURRRENT_LINE, 1, line1
                callb   CURRRENT_LINE, 2, line2
                callb   CURRRENT_LINE, 3, line3
                movwf   OUT              ;zapamietaj dana

                movwf   OUT1                 
                andl    OUT1, 0x03       ;przygotuj 1 polowe

                mov     OUT2, OUT
                andl    OUT2, 0x0c       ;przygotuj 2 polowe

                mov     OUTLED1, OUT2    ;wyslij dane do portu
                mov     OUTLED2, OUT1    ;wyslij dane do portu

                movl    DELAYN, 2        ;opoznienie stale

                call    delay1           ;wywolaj opozninie
                djnz    DELAYN, $ - 2    ;n razy

                incf    COUNT, F         ;zwieksz wskaznik
                andl    COUNT, 0x07      ;sprawdz czy koniec

                jb      P3, m_1          ;test klawisza P3
                movl    CURRRENT_LINE, 0x01
                clrf    COUNT            ;ustaw licznik pozycji
                call    delay1
                call    delay1
m_1:
                jb      P2, m_2          ;test klawisza P2
                movl    CURRRENT_LINE, 0x02
                clrf    COUNT            ;ustaw licznik pozycji
                call    delay1
                call    delay1
m_2:
                jb      P1, m_3          ;test klawisza P1
                movl    CURRRENT_LINE, 0x04
                clrf    COUNT            ;ustaw licznik pozycji
                call    delay1
                call    delay1
m_3:
                jb      P0, m_4          ;test klawisza P0
                movl    CURRRENT_LINE, 0x08
                clrf    COUNT            ;ustaw licznik pozycji
                call    delay1
                call    delay1
m_4:

                goto    main_1           ;petla glowna

;--------------------------------------------------------------------------

                end
